#ifndef _H_FFAF03744CBFDF525F525663716ECC0C_EsrEthTx__H_
#define _H_FFAF03744CBFDF525F525663716ECC0C_EsrEthTx__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  EsrEthTx_
            {
                struct _target_report_range__uniq_{};
                typedef ::DDS::Float _target_report_range__slice;
                typedef ::DDS::Float _target_report_range_[64];
                typedef DDS_DCPS_FArray_var< _target_report_range_, _target_report_range__slice, struct _target_report_range__uniq_ > _target_report_range__var;
                typedef _target_report_range_ _target_report_range__out;
                typedef DDS_DCPS_Array_forany< _target_report_range_, _target_report_range__slice, struct _target_report_range__uniq_ > _target_report_range__forany;
                static _target_report_range__slice *_target_report_range__alloc();
                static void _target_report_range__free(_target_report_range__slice *);
                static void _target_report_range__copy(_target_report_range__slice *to, const _target_report_range__slice *from);
                static _target_report_range__slice *_target_report_range__dup(const _target_report_range__slice *from);
                struct _target_report_range_rate__uniq_{};
                typedef ::DDS::Float _target_report_range_rate__slice;
                typedef ::DDS::Float _target_report_range_rate_[64];
                typedef DDS_DCPS_FArray_var< _target_report_range_rate_, _target_report_range_rate__slice, struct _target_report_range_rate__uniq_ > _target_report_range_rate__var;
                typedef _target_report_range_rate_ _target_report_range_rate__out;
                typedef DDS_DCPS_Array_forany< _target_report_range_rate_, _target_report_range_rate__slice, struct _target_report_range_rate__uniq_ > _target_report_range_rate__forany;
                static _target_report_range_rate__slice *_target_report_range_rate__alloc();
                static void _target_report_range_rate__free(_target_report_range_rate__slice *);
                static void _target_report_range_rate__copy(_target_report_range_rate__slice *to, const _target_report_range_rate__slice *from);
                static _target_report_range_rate__slice *_target_report_range_rate__dup(const _target_report_range_rate__slice *from);
                struct _target_report_theta__uniq_{};
                typedef ::DDS::Float _target_report_theta__slice;
                typedef ::DDS::Float _target_report_theta_[64];
                typedef DDS_DCPS_FArray_var< _target_report_theta_, _target_report_theta__slice, struct _target_report_theta__uniq_ > _target_report_theta__var;
                typedef _target_report_theta_ _target_report_theta__out;
                typedef DDS_DCPS_Array_forany< _target_report_theta_, _target_report_theta__slice, struct _target_report_theta__uniq_ > _target_report_theta__forany;
                static _target_report_theta__slice *_target_report_theta__alloc();
                static void _target_report_theta__free(_target_report_theta__slice *);
                static void _target_report_theta__copy(_target_report_theta__slice *to, const _target_report_theta__slice *from);
                static _target_report_theta__slice *_target_report_theta__dup(const _target_report_theta__slice *from);
                struct _target_report_amplitude__uniq_{};
                typedef ::DDS::Float _target_report_amplitude__slice;
                typedef ::DDS::Float _target_report_amplitude_[64];
                typedef DDS_DCPS_FArray_var< _target_report_amplitude_, _target_report_amplitude__slice, struct _target_report_amplitude__uniq_ > _target_report_amplitude__var;
                typedef _target_report_amplitude_ _target_report_amplitude__out;
                typedef DDS_DCPS_Array_forany< _target_report_amplitude_, _target_report_amplitude__slice, struct _target_report_amplitude__uniq_ > _target_report_amplitude__forany;
                static _target_report_amplitude__slice *_target_report_amplitude__alloc();
                static void _target_report_amplitude__free(_target_report_amplitude__slice *);
                static void _target_report_amplitude__copy(_target_report_amplitude__slice *to, const _target_report_amplitude__slice *from);
                static _target_report_amplitude__slice *_target_report_amplitude__dup(const _target_report_amplitude__slice *from);
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::UShort xcp_format_version_;
                ::DDS::UShort scan_index_;
                ::DDS::UShort tcp_size_;
                ::DDS::Octet xcp_scan_type_;
                ::DDS::UShort look_index_;
                ::DDS::UShort mmr_scan_index_;
                ::DDS::Float target_report_host_speed_;
                ::DDS::Float target_report_host_yaw_rate_;
                ::DDS::ULong xcp_timestamp_;
                ::DDS::Octet release_revision_;
                ::DDS::Octet promote_revision_;
                ::DDS::Octet field_revision_;
                ::DDS::Octet target_report_count_;
                _target_report_range_ target_report_range_;
                _target_report_range_rate_ target_report_range_rate_;
                _target_report_theta_ target_report_theta_;
                _target_report_amplitude_ target_report_amplitude_;
            };

            typedef DDS_DCPSStruct_var<EsrEthTx_> EsrEthTx__var;
            typedef DDS_DCPSStruct_out < EsrEthTx_> EsrEthTx__out;

        }

    }

}

#endif /* _H_FFAF03744CBFDF525F525663716ECC0C_EsrEthTx__H_ */
