#ifndef _H_3B23860DD82FFAF785F0DD8DDD7A95C2_EsrStatus2_DCPS_H_
#define _H_3B23860DD82FFAF785F0DD8DDD7A95C2_EsrStatus2_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrStatus2_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrStatus2_TypeSupportInterface;

            typedef EsrStatus2_TypeSupportInterface * EsrStatus2_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus2_TypeSupportInterface> EsrStatus2_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrStatus2_TypeSupportInterface> EsrStatus2_TypeSupportInterface_out;


            class EsrStatus2_DataWriter;

            typedef EsrStatus2_DataWriter * EsrStatus2_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus2_DataWriter> EsrStatus2_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrStatus2_DataWriter> EsrStatus2_DataWriter_out;


            class EsrStatus2_DataReader;

            typedef EsrStatus2_DataReader * EsrStatus2_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus2_DataReader> EsrStatus2_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrStatus2_DataReader> EsrStatus2_DataReader_out;


            class EsrStatus2_DataReaderView;

            typedef EsrStatus2_DataReaderView * EsrStatus2_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus2_DataReaderView> EsrStatus2_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrStatus2_DataReaderView> EsrStatus2_DataReaderView_out;

            struct EsrStatus2_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrStatus2_, struct EsrStatus2_Seq_uniq_> EsrStatus2_Seq;
            typedef DDS_DCPSSequence_var < EsrStatus2_Seq> EsrStatus2_Seq_var;
            typedef DDS_DCPSSequence_out < EsrStatus2_Seq> EsrStatus2_Seq_out;

            class  EsrStatus2_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrStatus2_TypeSupportInterface_ptr _ptr_type;
                typedef EsrStatus2_TypeSupportInterface_var _var_type;

                static EsrStatus2_TypeSupportInterface_ptr _duplicate (EsrStatus2_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus2_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus2_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus2_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus2_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrStatus2_TypeSupportInterface () {};
                ~EsrStatus2_TypeSupportInterface () {};
            private:
                EsrStatus2_TypeSupportInterface (const EsrStatus2_TypeSupportInterface &);
                EsrStatus2_TypeSupportInterface & operator = (const EsrStatus2_TypeSupportInterface &);
            };

            class  EsrStatus2_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrStatus2_DataWriter_ptr _ptr_type;
                typedef EsrStatus2_DataWriter_var _var_type;

                static EsrStatus2_DataWriter_ptr _duplicate (EsrStatus2_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus2_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus2_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus2_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus2_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrStatus2_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrStatus2_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrStatus2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrStatus2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrStatus2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrStatus2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrStatus2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrStatus2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrStatus2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrStatus2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrStatus2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus2_& instance_data) = 0;

            protected:
                EsrStatus2_DataWriter () {};
                ~EsrStatus2_DataWriter () {};
            private:
                EsrStatus2_DataWriter (const EsrStatus2_DataWriter &);
                EsrStatus2_DataWriter & operator = (const EsrStatus2_DataWriter &);
            };

            class  EsrStatus2_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrStatus2_DataReader_ptr _ptr_type;
                typedef EsrStatus2_DataReader_var _var_type;

                static EsrStatus2_DataReader_ptr _duplicate (EsrStatus2_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus2_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus2_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus2_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus2_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus2_& instance) = 0;

            protected:
                EsrStatus2_DataReader () {};
                ~EsrStatus2_DataReader () {};
            private:
                EsrStatus2_DataReader (const EsrStatus2_DataReader &);
                EsrStatus2_DataReader & operator = (const EsrStatus2_DataReader &);
            };

            class  EsrStatus2_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrStatus2_DataReaderView_ptr _ptr_type;
                typedef EsrStatus2_DataReaderView_var _var_type;

                static EsrStatus2_DataReaderView_ptr _duplicate (EsrStatus2_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus2_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus2_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus2_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus2_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus2_& instance) = 0;

            protected:
                EsrStatus2_DataReaderView () {};
                ~EsrStatus2_DataReaderView () {};
            private:
                EsrStatus2_DataReaderView (const EsrStatus2_DataReaderView &);
                EsrStatus2_DataReaderView & operator = (const EsrStatus2_DataReaderView &);
            };
        }

    }

}

#endif
