#ifndef _H_1BBE478875F4C03A8D927EC6D4AC9439_EsrStatus4_DCPS_H_
#define _H_1BBE478875F4C03A8D927EC6D4AC9439_EsrStatus4_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrStatus4_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrStatus4_TypeSupportInterface;

            typedef EsrStatus4_TypeSupportInterface * EsrStatus4_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus4_TypeSupportInterface> EsrStatus4_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrStatus4_TypeSupportInterface> EsrStatus4_TypeSupportInterface_out;


            class EsrStatus4_DataWriter;

            typedef EsrStatus4_DataWriter * EsrStatus4_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus4_DataWriter> EsrStatus4_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrStatus4_DataWriter> EsrStatus4_DataWriter_out;


            class EsrStatus4_DataReader;

            typedef EsrStatus4_DataReader * EsrStatus4_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus4_DataReader> EsrStatus4_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrStatus4_DataReader> EsrStatus4_DataReader_out;


            class EsrStatus4_DataReaderView;

            typedef EsrStatus4_DataReaderView * EsrStatus4_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus4_DataReaderView> EsrStatus4_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrStatus4_DataReaderView> EsrStatus4_DataReaderView_out;

            struct EsrStatus4_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrStatus4_, struct EsrStatus4_Seq_uniq_> EsrStatus4_Seq;
            typedef DDS_DCPSSequence_var < EsrStatus4_Seq> EsrStatus4_Seq_var;
            typedef DDS_DCPSSequence_out < EsrStatus4_Seq> EsrStatus4_Seq_out;

            class  EsrStatus4_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrStatus4_TypeSupportInterface_ptr _ptr_type;
                typedef EsrStatus4_TypeSupportInterface_var _var_type;

                static EsrStatus4_TypeSupportInterface_ptr _duplicate (EsrStatus4_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus4_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus4_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus4_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus4_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrStatus4_TypeSupportInterface () {};
                ~EsrStatus4_TypeSupportInterface () {};
            private:
                EsrStatus4_TypeSupportInterface (const EsrStatus4_TypeSupportInterface &);
                EsrStatus4_TypeSupportInterface & operator = (const EsrStatus4_TypeSupportInterface &);
            };

            class  EsrStatus4_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrStatus4_DataWriter_ptr _ptr_type;
                typedef EsrStatus4_DataWriter_var _var_type;

                static EsrStatus4_DataWriter_ptr _duplicate (EsrStatus4_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus4_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus4_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus4_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus4_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrStatus4_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrStatus4_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrStatus4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrStatus4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrStatus4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrStatus4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrStatus4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrStatus4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrStatus4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrStatus4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrStatus4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus4_& instance_data) = 0;

            protected:
                EsrStatus4_DataWriter () {};
                ~EsrStatus4_DataWriter () {};
            private:
                EsrStatus4_DataWriter (const EsrStatus4_DataWriter &);
                EsrStatus4_DataWriter & operator = (const EsrStatus4_DataWriter &);
            };

            class  EsrStatus4_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrStatus4_DataReader_ptr _ptr_type;
                typedef EsrStatus4_DataReader_var _var_type;

                static EsrStatus4_DataReader_ptr _duplicate (EsrStatus4_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus4_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus4_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus4_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus4_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus4_& instance) = 0;

            protected:
                EsrStatus4_DataReader () {};
                ~EsrStatus4_DataReader () {};
            private:
                EsrStatus4_DataReader (const EsrStatus4_DataReader &);
                EsrStatus4_DataReader & operator = (const EsrStatus4_DataReader &);
            };

            class  EsrStatus4_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrStatus4_DataReaderView_ptr _ptr_type;
                typedef EsrStatus4_DataReaderView_var _var_type;

                static EsrStatus4_DataReaderView_ptr _duplicate (EsrStatus4_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus4_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus4_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus4_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus4_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus4_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus4_& instance) = 0;

            protected:
                EsrStatus4_DataReaderView () {};
                ~EsrStatus4_DataReaderView () {};
            private:
                EsrStatus4_DataReaderView (const EsrStatus4_DataReaderView &);
                EsrStatus4_DataReaderView & operator = (const EsrStatus4_DataReaderView &);
            };
        }

    }

}

#endif
