#ifndef _H_AE86572623160329D1B7B5C459763A49_EsrStatus6_DCPS_H_
#define _H_AE86572623160329D1B7B5C459763A49_EsrStatus6_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrStatus6_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrStatus6_TypeSupportInterface;

            typedef EsrStatus6_TypeSupportInterface * EsrStatus6_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus6_TypeSupportInterface> EsrStatus6_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrStatus6_TypeSupportInterface> EsrStatus6_TypeSupportInterface_out;


            class EsrStatus6_DataWriter;

            typedef EsrStatus6_DataWriter * EsrStatus6_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus6_DataWriter> EsrStatus6_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrStatus6_DataWriter> EsrStatus6_DataWriter_out;


            class EsrStatus6_DataReader;

            typedef EsrStatus6_DataReader * EsrStatus6_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus6_DataReader> EsrStatus6_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrStatus6_DataReader> EsrStatus6_DataReader_out;


            class EsrStatus6_DataReaderView;

            typedef EsrStatus6_DataReaderView * EsrStatus6_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus6_DataReaderView> EsrStatus6_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrStatus6_DataReaderView> EsrStatus6_DataReaderView_out;

            struct EsrStatus6_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrStatus6_, struct EsrStatus6_Seq_uniq_> EsrStatus6_Seq;
            typedef DDS_DCPSSequence_var < EsrStatus6_Seq> EsrStatus6_Seq_var;
            typedef DDS_DCPSSequence_out < EsrStatus6_Seq> EsrStatus6_Seq_out;

            class  EsrStatus6_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrStatus6_TypeSupportInterface_ptr _ptr_type;
                typedef EsrStatus6_TypeSupportInterface_var _var_type;

                static EsrStatus6_TypeSupportInterface_ptr _duplicate (EsrStatus6_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus6_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus6_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus6_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus6_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrStatus6_TypeSupportInterface () {};
                ~EsrStatus6_TypeSupportInterface () {};
            private:
                EsrStatus6_TypeSupportInterface (const EsrStatus6_TypeSupportInterface &);
                EsrStatus6_TypeSupportInterface & operator = (const EsrStatus6_TypeSupportInterface &);
            };

            class  EsrStatus6_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrStatus6_DataWriter_ptr _ptr_type;
                typedef EsrStatus6_DataWriter_var _var_type;

                static EsrStatus6_DataWriter_ptr _duplicate (EsrStatus6_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus6_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus6_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus6_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus6_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrStatus6_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrStatus6_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrStatus6_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrStatus6_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrStatus6_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrStatus6_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrStatus6_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrStatus6_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrStatus6_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrStatus6_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrStatus6_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus6_& instance_data) = 0;

            protected:
                EsrStatus6_DataWriter () {};
                ~EsrStatus6_DataWriter () {};
            private:
                EsrStatus6_DataWriter (const EsrStatus6_DataWriter &);
                EsrStatus6_DataWriter & operator = (const EsrStatus6_DataWriter &);
            };

            class  EsrStatus6_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrStatus6_DataReader_ptr _ptr_type;
                typedef EsrStatus6_DataReader_var _var_type;

                static EsrStatus6_DataReader_ptr _duplicate (EsrStatus6_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus6_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus6_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus6_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus6_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus6_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus6_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus6_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus6_& instance) = 0;

            protected:
                EsrStatus6_DataReader () {};
                ~EsrStatus6_DataReader () {};
            private:
                EsrStatus6_DataReader (const EsrStatus6_DataReader &);
                EsrStatus6_DataReader & operator = (const EsrStatus6_DataReader &);
            };

            class  EsrStatus6_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrStatus6_DataReaderView_ptr _ptr_type;
                typedef EsrStatus6_DataReaderView_var _var_type;

                static EsrStatus6_DataReaderView_ptr _duplicate (EsrStatus6_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus6_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus6_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus6_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus6_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus6_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus6_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus6_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus6_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus6_& instance) = 0;

            protected:
                EsrStatus6_DataReaderView () {};
                ~EsrStatus6_DataReaderView () {};
            private:
                EsrStatus6_DataReaderView (const EsrStatus6_DataReaderView &);
                EsrStatus6_DataReaderView & operator = (const EsrStatus6_DataReaderView &);
            };
        }

    }

}

#endif
