#ifndef _H_27295D221D15F32835A47344CC21C593_EsrStatus7_DCPS_H_
#define _H_27295D221D15F32835A47344CC21C593_EsrStatus7_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrStatus7_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrStatus7_TypeSupportInterface;

            typedef EsrStatus7_TypeSupportInterface * EsrStatus7_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus7_TypeSupportInterface> EsrStatus7_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrStatus7_TypeSupportInterface> EsrStatus7_TypeSupportInterface_out;


            class EsrStatus7_DataWriter;

            typedef EsrStatus7_DataWriter * EsrStatus7_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus7_DataWriter> EsrStatus7_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrStatus7_DataWriter> EsrStatus7_DataWriter_out;


            class EsrStatus7_DataReader;

            typedef EsrStatus7_DataReader * EsrStatus7_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus7_DataReader> EsrStatus7_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrStatus7_DataReader> EsrStatus7_DataReader_out;


            class EsrStatus7_DataReaderView;

            typedef EsrStatus7_DataReaderView * EsrStatus7_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus7_DataReaderView> EsrStatus7_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrStatus7_DataReaderView> EsrStatus7_DataReaderView_out;

            struct EsrStatus7_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrStatus7_, struct EsrStatus7_Seq_uniq_> EsrStatus7_Seq;
            typedef DDS_DCPSSequence_var < EsrStatus7_Seq> EsrStatus7_Seq_var;
            typedef DDS_DCPSSequence_out < EsrStatus7_Seq> EsrStatus7_Seq_out;

            class  EsrStatus7_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrStatus7_TypeSupportInterface_ptr _ptr_type;
                typedef EsrStatus7_TypeSupportInterface_var _var_type;

                static EsrStatus7_TypeSupportInterface_ptr _duplicate (EsrStatus7_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus7_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus7_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus7_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus7_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrStatus7_TypeSupportInterface () {};
                ~EsrStatus7_TypeSupportInterface () {};
            private:
                EsrStatus7_TypeSupportInterface (const EsrStatus7_TypeSupportInterface &);
                EsrStatus7_TypeSupportInterface & operator = (const EsrStatus7_TypeSupportInterface &);
            };

            class  EsrStatus7_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrStatus7_DataWriter_ptr _ptr_type;
                typedef EsrStatus7_DataWriter_var _var_type;

                static EsrStatus7_DataWriter_ptr _duplicate (EsrStatus7_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus7_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus7_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus7_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus7_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrStatus7_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrStatus7_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrStatus7_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrStatus7_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrStatus7_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrStatus7_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrStatus7_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrStatus7_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrStatus7_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrStatus7_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrStatus7_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus7_& instance_data) = 0;

            protected:
                EsrStatus7_DataWriter () {};
                ~EsrStatus7_DataWriter () {};
            private:
                EsrStatus7_DataWriter (const EsrStatus7_DataWriter &);
                EsrStatus7_DataWriter & operator = (const EsrStatus7_DataWriter &);
            };

            class  EsrStatus7_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrStatus7_DataReader_ptr _ptr_type;
                typedef EsrStatus7_DataReader_var _var_type;

                static EsrStatus7_DataReader_ptr _duplicate (EsrStatus7_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus7_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus7_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus7_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus7_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus7_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus7_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus7_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus7_& instance) = 0;

            protected:
                EsrStatus7_DataReader () {};
                ~EsrStatus7_DataReader () {};
            private:
                EsrStatus7_DataReader (const EsrStatus7_DataReader &);
                EsrStatus7_DataReader & operator = (const EsrStatus7_DataReader &);
            };

            class  EsrStatus7_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrStatus7_DataReaderView_ptr _ptr_type;
                typedef EsrStatus7_DataReaderView_var _var_type;

                static EsrStatus7_DataReaderView_ptr _duplicate (EsrStatus7_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus7_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus7_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus7_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus7_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus7_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus7_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus7_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus7_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus7_& instance) = 0;

            protected:
                EsrStatus7_DataReaderView () {};
                ~EsrStatus7_DataReaderView () {};
            private:
                EsrStatus7_DataReaderView (const EsrStatus7_DataReaderView &);
                EsrStatus7_DataReaderView & operator = (const EsrStatus7_DataReaderView &);
            };
        }

    }

}

#endif
