#ifndef _H_4331619D2EECBD619AC839580257A201_EsrStatus9_DCPS_H_
#define _H_4331619D2EECBD619AC839580257A201_EsrStatus9_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrStatus9_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrStatus9_TypeSupportInterface;

            typedef EsrStatus9_TypeSupportInterface * EsrStatus9_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus9_TypeSupportInterface> EsrStatus9_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrStatus9_TypeSupportInterface> EsrStatus9_TypeSupportInterface_out;


            class EsrStatus9_DataWriter;

            typedef EsrStatus9_DataWriter * EsrStatus9_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus9_DataWriter> EsrStatus9_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrStatus9_DataWriter> EsrStatus9_DataWriter_out;


            class EsrStatus9_DataReader;

            typedef EsrStatus9_DataReader * EsrStatus9_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus9_DataReader> EsrStatus9_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrStatus9_DataReader> EsrStatus9_DataReader_out;


            class EsrStatus9_DataReaderView;

            typedef EsrStatus9_DataReaderView * EsrStatus9_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus9_DataReaderView> EsrStatus9_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrStatus9_DataReaderView> EsrStatus9_DataReaderView_out;

            struct EsrStatus9_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrStatus9_, struct EsrStatus9_Seq_uniq_> EsrStatus9_Seq;
            typedef DDS_DCPSSequence_var < EsrStatus9_Seq> EsrStatus9_Seq_var;
            typedef DDS_DCPSSequence_out < EsrStatus9_Seq> EsrStatus9_Seq_out;

            class  EsrStatus9_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrStatus9_TypeSupportInterface_ptr _ptr_type;
                typedef EsrStatus9_TypeSupportInterface_var _var_type;

                static EsrStatus9_TypeSupportInterface_ptr _duplicate (EsrStatus9_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus9_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus9_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus9_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus9_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrStatus9_TypeSupportInterface () {};
                ~EsrStatus9_TypeSupportInterface () {};
            private:
                EsrStatus9_TypeSupportInterface (const EsrStatus9_TypeSupportInterface &);
                EsrStatus9_TypeSupportInterface & operator = (const EsrStatus9_TypeSupportInterface &);
            };

            class  EsrStatus9_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrStatus9_DataWriter_ptr _ptr_type;
                typedef EsrStatus9_DataWriter_var _var_type;

                static EsrStatus9_DataWriter_ptr _duplicate (EsrStatus9_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus9_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus9_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus9_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus9_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrStatus9_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrStatus9_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrStatus9_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrStatus9_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrStatus9_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrStatus9_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrStatus9_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrStatus9_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrStatus9_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrStatus9_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrStatus9_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus9_& instance_data) = 0;

            protected:
                EsrStatus9_DataWriter () {};
                ~EsrStatus9_DataWriter () {};
            private:
                EsrStatus9_DataWriter (const EsrStatus9_DataWriter &);
                EsrStatus9_DataWriter & operator = (const EsrStatus9_DataWriter &);
            };

            class  EsrStatus9_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrStatus9_DataReader_ptr _ptr_type;
                typedef EsrStatus9_DataReader_var _var_type;

                static EsrStatus9_DataReader_ptr _duplicate (EsrStatus9_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus9_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus9_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus9_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus9_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus9_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus9_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus9_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus9_& instance) = 0;

            protected:
                EsrStatus9_DataReader () {};
                ~EsrStatus9_DataReader () {};
            private:
                EsrStatus9_DataReader (const EsrStatus9_DataReader &);
                EsrStatus9_DataReader & operator = (const EsrStatus9_DataReader &);
            };

            class  EsrStatus9_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrStatus9_DataReaderView_ptr _ptr_type;
                typedef EsrStatus9_DataReaderView_var _var_type;

                static EsrStatus9_DataReaderView_ptr _duplicate (EsrStatus9_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus9_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus9_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus9_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus9_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus9_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus9_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus9_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus9_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus9_& instance) = 0;

            protected:
                EsrStatus9_DataReaderView () {};
                ~EsrStatus9_DataReaderView () {};
            private:
                EsrStatus9_DataReaderView (const EsrStatus9_DataReaderView &);
                EsrStatus9_DataReaderView & operator = (const EsrStatus9_DataReaderView &);
            };
        }

    }

}

#endif
