#ifndef _H_5AA2576A40C4D574187EDD915EFDD1D5_EsrTrackMotionPower_DCPS_H_
#define _H_5AA2576A40C4D574187EDD915EFDD1D5_EsrTrackMotionPower_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrTrackMotionPower_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrTrackMotionPower_TypeSupportInterface;

            typedef EsrTrackMotionPower_TypeSupportInterface * EsrTrackMotionPower_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrTrackMotionPower_TypeSupportInterface> EsrTrackMotionPower_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrTrackMotionPower_TypeSupportInterface> EsrTrackMotionPower_TypeSupportInterface_out;


            class EsrTrackMotionPower_DataWriter;

            typedef EsrTrackMotionPower_DataWriter * EsrTrackMotionPower_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrTrackMotionPower_DataWriter> EsrTrackMotionPower_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrTrackMotionPower_DataWriter> EsrTrackMotionPower_DataWriter_out;


            class EsrTrackMotionPower_DataReader;

            typedef EsrTrackMotionPower_DataReader * EsrTrackMotionPower_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrTrackMotionPower_DataReader> EsrTrackMotionPower_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrTrackMotionPower_DataReader> EsrTrackMotionPower_DataReader_out;


            class EsrTrackMotionPower_DataReaderView;

            typedef EsrTrackMotionPower_DataReaderView * EsrTrackMotionPower_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrTrackMotionPower_DataReaderView> EsrTrackMotionPower_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrTrackMotionPower_DataReaderView> EsrTrackMotionPower_DataReaderView_out;

            struct EsrTrackMotionPower_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrTrackMotionPower_, struct EsrTrackMotionPower_Seq_uniq_> EsrTrackMotionPower_Seq;
            typedef DDS_DCPSSequence_var < EsrTrackMotionPower_Seq> EsrTrackMotionPower_Seq_var;
            typedef DDS_DCPSSequence_out < EsrTrackMotionPower_Seq> EsrTrackMotionPower_Seq_out;

            class  EsrTrackMotionPower_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrTrackMotionPower_TypeSupportInterface_ptr _ptr_type;
                typedef EsrTrackMotionPower_TypeSupportInterface_var _var_type;

                static EsrTrackMotionPower_TypeSupportInterface_ptr _duplicate (EsrTrackMotionPower_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrTrackMotionPower_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrTrackMotionPower_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrTrackMotionPower_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrTrackMotionPower_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrTrackMotionPower_TypeSupportInterface () {};
                ~EsrTrackMotionPower_TypeSupportInterface () {};
            private:
                EsrTrackMotionPower_TypeSupportInterface (const EsrTrackMotionPower_TypeSupportInterface &);
                EsrTrackMotionPower_TypeSupportInterface & operator = (const EsrTrackMotionPower_TypeSupportInterface &);
            };

            class  EsrTrackMotionPower_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrTrackMotionPower_DataWriter_ptr _ptr_type;
                typedef EsrTrackMotionPower_DataWriter_var _var_type;

                static EsrTrackMotionPower_DataWriter_ptr _duplicate (EsrTrackMotionPower_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrTrackMotionPower_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrTrackMotionPower_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrTrackMotionPower_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrTrackMotionPower_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrTrackMotionPower_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrTrackMotionPower_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrTrackMotionPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrTrackMotionPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrTrackMotionPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrTrackMotionPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrTrackMotionPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrTrackMotionPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrTrackMotionPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrTrackMotionPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrTrackMotionPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrTrackMotionPower_& instance_data) = 0;

            protected:
                EsrTrackMotionPower_DataWriter () {};
                ~EsrTrackMotionPower_DataWriter () {};
            private:
                EsrTrackMotionPower_DataWriter (const EsrTrackMotionPower_DataWriter &);
                EsrTrackMotionPower_DataWriter & operator = (const EsrTrackMotionPower_DataWriter &);
            };

            class  EsrTrackMotionPower_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrTrackMotionPower_DataReader_ptr _ptr_type;
                typedef EsrTrackMotionPower_DataReader_var _var_type;

                static EsrTrackMotionPower_DataReader_ptr _duplicate (EsrTrackMotionPower_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrTrackMotionPower_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrTrackMotionPower_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrTrackMotionPower_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrTrackMotionPower_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrTrackMotionPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrTrackMotionPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrTrackMotionPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrTrackMotionPower_& instance) = 0;

            protected:
                EsrTrackMotionPower_DataReader () {};
                ~EsrTrackMotionPower_DataReader () {};
            private:
                EsrTrackMotionPower_DataReader (const EsrTrackMotionPower_DataReader &);
                EsrTrackMotionPower_DataReader & operator = (const EsrTrackMotionPower_DataReader &);
            };

            class  EsrTrackMotionPower_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrTrackMotionPower_DataReaderView_ptr _ptr_type;
                typedef EsrTrackMotionPower_DataReaderView_var _var_type;

                static EsrTrackMotionPower_DataReaderView_ptr _duplicate (EsrTrackMotionPower_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrTrackMotionPower_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrTrackMotionPower_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrTrackMotionPower_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrTrackMotionPower_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrTrackMotionPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrTrackMotionPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrTrackMotionPower_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrTrackMotionPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrTrackMotionPower_& instance) = 0;

            protected:
                EsrTrackMotionPower_DataReaderView () {};
                ~EsrTrackMotionPower_DataReaderView () {};
            private:
                EsrTrackMotionPower_DataReaderView (const EsrTrackMotionPower_DataReaderView &);
                EsrTrackMotionPower_DataReaderView & operator = (const EsrTrackMotionPower_DataReaderView &);
            };
        }

    }

}

#endif
