#ifndef _H_4AD8329C699E0BFE82ABA4373137C437_EsrTrack_DCPS_H_
#define _H_4AD8329C699E0BFE82ABA4373137C437_EsrTrack_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrTrack_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrTrack_TypeSupportInterface;

            typedef EsrTrack_TypeSupportInterface * EsrTrack_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrTrack_TypeSupportInterface> EsrTrack_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrTrack_TypeSupportInterface> EsrTrack_TypeSupportInterface_out;


            class EsrTrack_DataWriter;

            typedef EsrTrack_DataWriter * EsrTrack_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrTrack_DataWriter> EsrTrack_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrTrack_DataWriter> EsrTrack_DataWriter_out;


            class EsrTrack_DataReader;

            typedef EsrTrack_DataReader * EsrTrack_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrTrack_DataReader> EsrTrack_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrTrack_DataReader> EsrTrack_DataReader_out;


            class EsrTrack_DataReaderView;

            typedef EsrTrack_DataReaderView * EsrTrack_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrTrack_DataReaderView> EsrTrack_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrTrack_DataReaderView> EsrTrack_DataReaderView_out;

            struct EsrTrack_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrTrack_, struct EsrTrack_Seq_uniq_> EsrTrack_Seq;
            typedef DDS_DCPSSequence_var < EsrTrack_Seq> EsrTrack_Seq_var;
            typedef DDS_DCPSSequence_out < EsrTrack_Seq> EsrTrack_Seq_out;

            class  EsrTrack_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrTrack_TypeSupportInterface_ptr _ptr_type;
                typedef EsrTrack_TypeSupportInterface_var _var_type;

                static EsrTrack_TypeSupportInterface_ptr _duplicate (EsrTrack_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrTrack_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrTrack_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrTrack_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrTrack_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrTrack_TypeSupportInterface () {};
                ~EsrTrack_TypeSupportInterface () {};
            private:
                EsrTrack_TypeSupportInterface (const EsrTrack_TypeSupportInterface &);
                EsrTrack_TypeSupportInterface & operator = (const EsrTrack_TypeSupportInterface &);
            };

            class  EsrTrack_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrTrack_DataWriter_ptr _ptr_type;
                typedef EsrTrack_DataWriter_var _var_type;

                static EsrTrack_DataWriter_ptr _duplicate (EsrTrack_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrTrack_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrTrack_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrTrack_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrTrack_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrTrack_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrTrack_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrTrack_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrTrack_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrTrack_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrTrack_& instance_data) = 0;

            protected:
                EsrTrack_DataWriter () {};
                ~EsrTrack_DataWriter () {};
            private:
                EsrTrack_DataWriter (const EsrTrack_DataWriter &);
                EsrTrack_DataWriter & operator = (const EsrTrack_DataWriter &);
            };

            class  EsrTrack_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrTrack_DataReader_ptr _ptr_type;
                typedef EsrTrack_DataReader_var _var_type;

                static EsrTrack_DataReader_ptr _duplicate (EsrTrack_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrTrack_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrTrack_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrTrack_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrTrack_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrTrack_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrTrack_& instance) = 0;

            protected:
                EsrTrack_DataReader () {};
                ~EsrTrack_DataReader () {};
            private:
                EsrTrack_DataReader (const EsrTrack_DataReader &);
                EsrTrack_DataReader & operator = (const EsrTrack_DataReader &);
            };

            class  EsrTrack_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrTrack_DataReaderView_ptr _ptr_type;
                typedef EsrTrack_DataReaderView_var _var_type;

                static EsrTrack_DataReaderView_ptr _duplicate (EsrTrack_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrTrack_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrTrack_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrTrack_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrTrack_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrTrack_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrTrack_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrTrack_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrTrack_& instance) = 0;

            protected:
                EsrTrack_DataReaderView () {};
                ~EsrTrack_DataReaderView () {};
            private:
                EsrTrack_DataReaderView (const EsrTrack_DataReaderView &);
                EsrTrack_DataReaderView & operator = (const EsrTrack_DataReaderView &);
            };
        }

    }

}

#endif
