#ifndef _H_9E7A1C676E4AEC6D45C8591D1B182263_EsrValid1_DCPS_H_
#define _H_9E7A1C676E4AEC6D45C8591D1B182263_EsrValid1_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrValid1_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrValid1_TypeSupportInterface;

            typedef EsrValid1_TypeSupportInterface * EsrValid1_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrValid1_TypeSupportInterface> EsrValid1_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrValid1_TypeSupportInterface> EsrValid1_TypeSupportInterface_out;


            class EsrValid1_DataWriter;

            typedef EsrValid1_DataWriter * EsrValid1_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrValid1_DataWriter> EsrValid1_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrValid1_DataWriter> EsrValid1_DataWriter_out;


            class EsrValid1_DataReader;

            typedef EsrValid1_DataReader * EsrValid1_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrValid1_DataReader> EsrValid1_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrValid1_DataReader> EsrValid1_DataReader_out;


            class EsrValid1_DataReaderView;

            typedef EsrValid1_DataReaderView * EsrValid1_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrValid1_DataReaderView> EsrValid1_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrValid1_DataReaderView> EsrValid1_DataReaderView_out;

            struct EsrValid1_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrValid1_, struct EsrValid1_Seq_uniq_> EsrValid1_Seq;
            typedef DDS_DCPSSequence_var < EsrValid1_Seq> EsrValid1_Seq_var;
            typedef DDS_DCPSSequence_out < EsrValid1_Seq> EsrValid1_Seq_out;

            class  EsrValid1_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrValid1_TypeSupportInterface_ptr _ptr_type;
                typedef EsrValid1_TypeSupportInterface_var _var_type;

                static EsrValid1_TypeSupportInterface_ptr _duplicate (EsrValid1_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrValid1_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrValid1_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrValid1_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrValid1_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrValid1_TypeSupportInterface () {};
                ~EsrValid1_TypeSupportInterface () {};
            private:
                EsrValid1_TypeSupportInterface (const EsrValid1_TypeSupportInterface &);
                EsrValid1_TypeSupportInterface & operator = (const EsrValid1_TypeSupportInterface &);
            };

            class  EsrValid1_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrValid1_DataWriter_ptr _ptr_type;
                typedef EsrValid1_DataWriter_var _var_type;

                static EsrValid1_DataWriter_ptr _duplicate (EsrValid1_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrValid1_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrValid1_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrValid1_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrValid1_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrValid1_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrValid1_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrValid1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrValid1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrValid1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrValid1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrValid1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrValid1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrValid1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrValid1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrValid1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrValid1_& instance_data) = 0;

            protected:
                EsrValid1_DataWriter () {};
                ~EsrValid1_DataWriter () {};
            private:
                EsrValid1_DataWriter (const EsrValid1_DataWriter &);
                EsrValid1_DataWriter & operator = (const EsrValid1_DataWriter &);
            };

            class  EsrValid1_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrValid1_DataReader_ptr _ptr_type;
                typedef EsrValid1_DataReader_var _var_type;

                static EsrValid1_DataReader_ptr _duplicate (EsrValid1_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrValid1_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrValid1_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrValid1_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrValid1_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrValid1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrValid1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrValid1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrValid1_& instance) = 0;

            protected:
                EsrValid1_DataReader () {};
                ~EsrValid1_DataReader () {};
            private:
                EsrValid1_DataReader (const EsrValid1_DataReader &);
                EsrValid1_DataReader & operator = (const EsrValid1_DataReader &);
            };

            class  EsrValid1_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrValid1_DataReaderView_ptr _ptr_type;
                typedef EsrValid1_DataReaderView_var _var_type;

                static EsrValid1_DataReaderView_ptr _duplicate (EsrValid1_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrValid1_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrValid1_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrValid1_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrValid1_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrValid1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrValid1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrValid1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrValid1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrValid1_& instance) = 0;

            protected:
                EsrValid1_DataReaderView () {};
                ~EsrValid1_DataReaderView () {};
            private:
                EsrValid1_DataReaderView (const EsrValid1_DataReaderView &);
                EsrValid1_DataReaderView & operator = (const EsrValid1_DataReaderView &);
            };
        }

    }

}

#endif
