#ifndef _H_5CF50FA7DD7416441654B0E1CF6EDA29_EsrVehicle1_DCPS_H_
#define _H_5CF50FA7DD7416441654B0E1CF6EDA29_EsrVehicle1_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrVehicle1_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrVehicle1_TypeSupportInterface;

            typedef EsrVehicle1_TypeSupportInterface * EsrVehicle1_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle1_TypeSupportInterface> EsrVehicle1_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrVehicle1_TypeSupportInterface> EsrVehicle1_TypeSupportInterface_out;


            class EsrVehicle1_DataWriter;

            typedef EsrVehicle1_DataWriter * EsrVehicle1_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle1_DataWriter> EsrVehicle1_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrVehicle1_DataWriter> EsrVehicle1_DataWriter_out;


            class EsrVehicle1_DataReader;

            typedef EsrVehicle1_DataReader * EsrVehicle1_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle1_DataReader> EsrVehicle1_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrVehicle1_DataReader> EsrVehicle1_DataReader_out;


            class EsrVehicle1_DataReaderView;

            typedef EsrVehicle1_DataReaderView * EsrVehicle1_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle1_DataReaderView> EsrVehicle1_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrVehicle1_DataReaderView> EsrVehicle1_DataReaderView_out;

            struct EsrVehicle1_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrVehicle1_, struct EsrVehicle1_Seq_uniq_> EsrVehicle1_Seq;
            typedef DDS_DCPSSequence_var < EsrVehicle1_Seq> EsrVehicle1_Seq_var;
            typedef DDS_DCPSSequence_out < EsrVehicle1_Seq> EsrVehicle1_Seq_out;

            class  EsrVehicle1_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrVehicle1_TypeSupportInterface_ptr _ptr_type;
                typedef EsrVehicle1_TypeSupportInterface_var _var_type;

                static EsrVehicle1_TypeSupportInterface_ptr _duplicate (EsrVehicle1_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle1_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle1_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle1_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle1_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrVehicle1_TypeSupportInterface () {};
                ~EsrVehicle1_TypeSupportInterface () {};
            private:
                EsrVehicle1_TypeSupportInterface (const EsrVehicle1_TypeSupportInterface &);
                EsrVehicle1_TypeSupportInterface & operator = (const EsrVehicle1_TypeSupportInterface &);
            };

            class  EsrVehicle1_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrVehicle1_DataWriter_ptr _ptr_type;
                typedef EsrVehicle1_DataWriter_var _var_type;

                static EsrVehicle1_DataWriter_ptr _duplicate (EsrVehicle1_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle1_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle1_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle1_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle1_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrVehicle1_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrVehicle1_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrVehicle1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrVehicle1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrVehicle1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrVehicle1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrVehicle1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrVehicle1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrVehicle1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrVehicle1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrVehicle1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle1_& instance_data) = 0;

            protected:
                EsrVehicle1_DataWriter () {};
                ~EsrVehicle1_DataWriter () {};
            private:
                EsrVehicle1_DataWriter (const EsrVehicle1_DataWriter &);
                EsrVehicle1_DataWriter & operator = (const EsrVehicle1_DataWriter &);
            };

            class  EsrVehicle1_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrVehicle1_DataReader_ptr _ptr_type;
                typedef EsrVehicle1_DataReader_var _var_type;

                static EsrVehicle1_DataReader_ptr _duplicate (EsrVehicle1_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle1_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle1_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle1_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle1_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrVehicle1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrVehicle1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrVehicle1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle1_& instance) = 0;

            protected:
                EsrVehicle1_DataReader () {};
                ~EsrVehicle1_DataReader () {};
            private:
                EsrVehicle1_DataReader (const EsrVehicle1_DataReader &);
                EsrVehicle1_DataReader & operator = (const EsrVehicle1_DataReader &);
            };

            class  EsrVehicle1_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrVehicle1_DataReaderView_ptr _ptr_type;
                typedef EsrVehicle1_DataReaderView_var _var_type;

                static EsrVehicle1_DataReaderView_ptr _duplicate (EsrVehicle1_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle1_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle1_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle1_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle1_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrVehicle1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrVehicle1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrVehicle1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrVehicle1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle1_& instance) = 0;

            protected:
                EsrVehicle1_DataReaderView () {};
                ~EsrVehicle1_DataReaderView () {};
            private:
                EsrVehicle1_DataReaderView (const EsrVehicle1_DataReaderView &);
                EsrVehicle1_DataReaderView & operator = (const EsrVehicle1_DataReaderView &);
            };
        }

    }

}

#endif
