#ifndef _H_B425B5A668B28ECF3A5D8B5B5D5BCB20_EsrVehicle2__H_
#define _H_B425B5A668B28ECF3A5D8B5B5D5BCB20_EsrVehicle2__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  EsrVehicle2_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::UShort scan_index_ack_;
                ::DDS::Boolean use_angle_misalignment_;
                ::DDS::Boolean clear_faults_;
                ::DDS::Octet high_yaw_angle_;
                ::DDS::Boolean mr_only_transmit_;
                ::DDS::Boolean lr_only_transmit_;
                ::DDS::Float angle_misalignment_;
                ::DDS::Float lateral_mounting_offset_;
                ::DDS::Boolean radar_cmd_radiate_;
                ::DDS::Boolean blockage_disable_;
                ::DDS::Octet maximum_tracks_;
                ::DDS::Octet turn_signal_status_;
                ::DDS::Boolean vehicle_speed_valid_;
                ::DDS::Boolean mmr_upside_down_;
                ::DDS::Octet grouping_mode_;
                ::DDS::Boolean wiper_status_;
                ::DDS::Boolean raw_data_enabled_;
            };

            typedef DDS_DCPSStruct_var<EsrVehicle2_> EsrVehicle2__var;
            typedef DDS_DCPSStruct_out < EsrVehicle2_> EsrVehicle2__out;

        }

    }

}

#endif /* _H_B425B5A668B28ECF3A5D8B5B5D5BCB20_EsrVehicle2__H_ */
