#ifndef _H_61E8B97FA0A1C8CAD84D72D6858C30DC_EsrVehicle4_DCPS_H_
#define _H_61E8B97FA0A1C8CAD84D72D6858C30DC_EsrVehicle4_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrVehicle4_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrVehicle4_TypeSupportInterface;

            typedef EsrVehicle4_TypeSupportInterface * EsrVehicle4_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle4_TypeSupportInterface> EsrVehicle4_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrVehicle4_TypeSupportInterface> EsrVehicle4_TypeSupportInterface_out;


            class EsrVehicle4_DataWriter;

            typedef EsrVehicle4_DataWriter * EsrVehicle4_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle4_DataWriter> EsrVehicle4_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrVehicle4_DataWriter> EsrVehicle4_DataWriter_out;


            class EsrVehicle4_DataReader;

            typedef EsrVehicle4_DataReader * EsrVehicle4_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle4_DataReader> EsrVehicle4_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrVehicle4_DataReader> EsrVehicle4_DataReader_out;


            class EsrVehicle4_DataReaderView;

            typedef EsrVehicle4_DataReaderView * EsrVehicle4_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle4_DataReaderView> EsrVehicle4_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrVehicle4_DataReaderView> EsrVehicle4_DataReaderView_out;

            struct EsrVehicle4_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrVehicle4_, struct EsrVehicle4_Seq_uniq_> EsrVehicle4_Seq;
            typedef DDS_DCPSSequence_var < EsrVehicle4_Seq> EsrVehicle4_Seq_var;
            typedef DDS_DCPSSequence_out < EsrVehicle4_Seq> EsrVehicle4_Seq_out;

            class  EsrVehicle4_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrVehicle4_TypeSupportInterface_ptr _ptr_type;
                typedef EsrVehicle4_TypeSupportInterface_var _var_type;

                static EsrVehicle4_TypeSupportInterface_ptr _duplicate (EsrVehicle4_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle4_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle4_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle4_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle4_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrVehicle4_TypeSupportInterface () {};
                ~EsrVehicle4_TypeSupportInterface () {};
            private:
                EsrVehicle4_TypeSupportInterface (const EsrVehicle4_TypeSupportInterface &);
                EsrVehicle4_TypeSupportInterface & operator = (const EsrVehicle4_TypeSupportInterface &);
            };

            class  EsrVehicle4_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrVehicle4_DataWriter_ptr _ptr_type;
                typedef EsrVehicle4_DataWriter_var _var_type;

                static EsrVehicle4_DataWriter_ptr _duplicate (EsrVehicle4_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle4_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle4_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle4_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle4_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrVehicle4_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrVehicle4_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrVehicle4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrVehicle4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrVehicle4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrVehicle4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrVehicle4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrVehicle4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrVehicle4_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrVehicle4_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrVehicle4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle4_& instance_data) = 0;

            protected:
                EsrVehicle4_DataWriter () {};
                ~EsrVehicle4_DataWriter () {};
            private:
                EsrVehicle4_DataWriter (const EsrVehicle4_DataWriter &);
                EsrVehicle4_DataWriter & operator = (const EsrVehicle4_DataWriter &);
            };

            class  EsrVehicle4_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrVehicle4_DataReader_ptr _ptr_type;
                typedef EsrVehicle4_DataReader_var _var_type;

                static EsrVehicle4_DataReader_ptr _duplicate (EsrVehicle4_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle4_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle4_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle4_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle4_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrVehicle4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrVehicle4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrVehicle4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle4_& instance) = 0;

            protected:
                EsrVehicle4_DataReader () {};
                ~EsrVehicle4_DataReader () {};
            private:
                EsrVehicle4_DataReader (const EsrVehicle4_DataReader &);
                EsrVehicle4_DataReader & operator = (const EsrVehicle4_DataReader &);
            };

            class  EsrVehicle4_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrVehicle4_DataReaderView_ptr _ptr_type;
                typedef EsrVehicle4_DataReaderView_var _var_type;

                static EsrVehicle4_DataReaderView_ptr _duplicate (EsrVehicle4_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle4_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle4_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle4_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle4_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrVehicle4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrVehicle4_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrVehicle4_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrVehicle4_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle4_& instance) = 0;

            protected:
                EsrVehicle4_DataReaderView () {};
                ~EsrVehicle4_DataReaderView () {};
            private:
                EsrVehicle4_DataReaderView (const EsrVehicle4_DataReaderView &);
                EsrVehicle4_DataReaderView & operator = (const EsrVehicle4_DataReaderView &);
            };
        }

    }

}

#endif
