#ifndef _H_0164E260CAFD75A66D148F593D7FB234_EsrVehicle5__H_
#define _H_0164E260CAFD75A66D148F593D7FB234_EsrVehicle5__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  EsrVehicle5_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet oversteer_understeer_;
                ::DDS::Boolean yaw_rate_bias_shift_;
                ::DDS::Float beamwidth_vert_;
                ::DDS::Float funnel_offset_left_;
                ::DDS::Float funnel_offset_right_;
                ::DDS::Float cw_blockage_threshold_;
                ::DDS::UShort distance_rear_axle_;
                ::DDS::UShort wheel_base_;
                ::DDS::Float steering_gear_ratio_;
            };

            typedef DDS_DCPSStruct_var<EsrVehicle5_> EsrVehicle5__var;
            typedef DDS_DCPSStruct_out < EsrVehicle5_> EsrVehicle5__out;

        }

    }

}

#endif /* _H_0164E260CAFD75A66D148F593D7FB234_EsrVehicle5__H_ */
