// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from delphi_esr_msgs:msg/EsrStatus4.idl
// generated code does not contain a copyright notice
#include "delphi_esr_msgs/msg/esr_status4__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `canmsg`
#include "rosidl_generator_c/string_functions.h"

bool
delphi_esr_msgs__msg__EsrStatus4__init(delphi_esr_msgs__msg__EsrStatus4 * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    delphi_esr_msgs__msg__EsrStatus4__fini(msg);
    return false;
  }
  // canmsg
  if (!rosidl_generator_c__String__init(&msg->canmsg)) {
    delphi_esr_msgs__msg__EsrStatus4__fini(msg);
    return false;
  }
  // rolling_count3
  // mrlr_mode
  // patial_blockage
  // side_lobe_blockage
  // lr_only_grating_lobe_det
  // truck_target_det
  // path_id_acc
  // path_id_cmmb_move
  // path_id_cmmb_stat
  // path_id_fcw_move
  // path_id_fcw_stat
  // path_id_acc_stat
  // auto_algin_angle
  return true;
}

void
delphi_esr_msgs__msg__EsrStatus4__fini(delphi_esr_msgs__msg__EsrStatus4 * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // canmsg
  rosidl_generator_c__String__fini(&msg->canmsg);
  // rolling_count3
  // mrlr_mode
  // patial_blockage
  // side_lobe_blockage
  // lr_only_grating_lobe_det
  // truck_target_det
  // path_id_acc
  // path_id_cmmb_move
  // path_id_cmmb_stat
  // path_id_fcw_move
  // path_id_fcw_stat
  // path_id_acc_stat
  // auto_algin_angle
}

delphi_esr_msgs__msg__EsrStatus4 *
delphi_esr_msgs__msg__EsrStatus4__create()
{
  delphi_esr_msgs__msg__EsrStatus4 * msg = (delphi_esr_msgs__msg__EsrStatus4 *)malloc(sizeof(delphi_esr_msgs__msg__EsrStatus4));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(delphi_esr_msgs__msg__EsrStatus4));
  bool success = delphi_esr_msgs__msg__EsrStatus4__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
delphi_esr_msgs__msg__EsrStatus4__destroy(delphi_esr_msgs__msg__EsrStatus4 * msg)
{
  if (msg) {
    delphi_esr_msgs__msg__EsrStatus4__fini(msg);
  }
  free(msg);
}


bool
delphi_esr_msgs__msg__EsrStatus4__Sequence__init(delphi_esr_msgs__msg__EsrStatus4__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  delphi_esr_msgs__msg__EsrStatus4 * data = NULL;
  if (size) {
    data = (delphi_esr_msgs__msg__EsrStatus4 *)calloc(size, sizeof(delphi_esr_msgs__msg__EsrStatus4));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = delphi_esr_msgs__msg__EsrStatus4__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        delphi_esr_msgs__msg__EsrStatus4__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
delphi_esr_msgs__msg__EsrStatus4__Sequence__fini(delphi_esr_msgs__msg__EsrStatus4__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      delphi_esr_msgs__msg__EsrStatus4__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

delphi_esr_msgs__msg__EsrStatus4__Sequence *
delphi_esr_msgs__msg__EsrStatus4__Sequence__create(size_t size)
{
  delphi_esr_msgs__msg__EsrStatus4__Sequence * array = (delphi_esr_msgs__msg__EsrStatus4__Sequence *)malloc(sizeof(delphi_esr_msgs__msg__EsrStatus4__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = delphi_esr_msgs__msg__EsrStatus4__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
delphi_esr_msgs__msg__EsrStatus4__Sequence__destroy(delphi_esr_msgs__msg__EsrStatus4__Sequence * array)
{
  if (array) {
    delphi_esr_msgs__msg__EsrStatus4__Sequence__fini(array);
  }
  free(array);
}
