#ifndef _H_FFAF03744CBFDF525F525663716ECC0C_EsrEthTx_DCPS_H_
#define _H_FFAF03744CBFDF525F525663716ECC0C_EsrEthTx_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrEthTx_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrEthTx_TypeSupportInterface;

            typedef EsrEthTx_TypeSupportInterface * EsrEthTx_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrEthTx_TypeSupportInterface> EsrEthTx_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrEthTx_TypeSupportInterface> EsrEthTx_TypeSupportInterface_out;


            class EsrEthTx_DataWriter;

            typedef EsrEthTx_DataWriter * EsrEthTx_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrEthTx_DataWriter> EsrEthTx_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrEthTx_DataWriter> EsrEthTx_DataWriter_out;


            class EsrEthTx_DataReader;

            typedef EsrEthTx_DataReader * EsrEthTx_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrEthTx_DataReader> EsrEthTx_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrEthTx_DataReader> EsrEthTx_DataReader_out;


            class EsrEthTx_DataReaderView;

            typedef EsrEthTx_DataReaderView * EsrEthTx_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrEthTx_DataReaderView> EsrEthTx_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrEthTx_DataReaderView> EsrEthTx_DataReaderView_out;

            struct EsrEthTx_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrEthTx_, struct EsrEthTx_Seq_uniq_> EsrEthTx_Seq;
            typedef DDS_DCPSSequence_var < EsrEthTx_Seq> EsrEthTx_Seq_var;
            typedef DDS_DCPSSequence_out < EsrEthTx_Seq> EsrEthTx_Seq_out;

            class  EsrEthTx_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrEthTx_TypeSupportInterface_ptr _ptr_type;
                typedef EsrEthTx_TypeSupportInterface_var _var_type;

                static EsrEthTx_TypeSupportInterface_ptr _duplicate (EsrEthTx_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrEthTx_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrEthTx_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrEthTx_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrEthTx_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrEthTx_TypeSupportInterface () {};
                ~EsrEthTx_TypeSupportInterface () {};
            private:
                EsrEthTx_TypeSupportInterface (const EsrEthTx_TypeSupportInterface &);
                EsrEthTx_TypeSupportInterface & operator = (const EsrEthTx_TypeSupportInterface &);
            };

            class  EsrEthTx_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrEthTx_DataWriter_ptr _ptr_type;
                typedef EsrEthTx_DataWriter_var _var_type;

                static EsrEthTx_DataWriter_ptr _duplicate (EsrEthTx_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrEthTx_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrEthTx_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrEthTx_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrEthTx_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrEthTx_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrEthTx_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrEthTx_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrEthTx_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrEthTx_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrEthTx_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrEthTx_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrEthTx_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrEthTx_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrEthTx_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrEthTx_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrEthTx_& instance_data) = 0;

            protected:
                EsrEthTx_DataWriter () {};
                ~EsrEthTx_DataWriter () {};
            private:
                EsrEthTx_DataWriter (const EsrEthTx_DataWriter &);
                EsrEthTx_DataWriter & operator = (const EsrEthTx_DataWriter &);
            };

            class  EsrEthTx_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrEthTx_DataReader_ptr _ptr_type;
                typedef EsrEthTx_DataReader_var _var_type;

                static EsrEthTx_DataReader_ptr _duplicate (EsrEthTx_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrEthTx_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrEthTx_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrEthTx_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrEthTx_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrEthTx_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrEthTx_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrEthTx_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrEthTx_& instance) = 0;

            protected:
                EsrEthTx_DataReader () {};
                ~EsrEthTx_DataReader () {};
            private:
                EsrEthTx_DataReader (const EsrEthTx_DataReader &);
                EsrEthTx_DataReader & operator = (const EsrEthTx_DataReader &);
            };

            class  EsrEthTx_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrEthTx_DataReaderView_ptr _ptr_type;
                typedef EsrEthTx_DataReaderView_var _var_type;

                static EsrEthTx_DataReaderView_ptr _duplicate (EsrEthTx_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrEthTx_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrEthTx_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrEthTx_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrEthTx_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrEthTx_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrEthTx_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrEthTx_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrEthTx_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrEthTx_& instance) = 0;

            protected:
                EsrEthTx_DataReaderView () {};
                ~EsrEthTx_DataReaderView () {};
            private:
                EsrEthTx_DataReaderView (const EsrEthTx_DataReaderView &);
                EsrEthTx_DataReaderView & operator = (const EsrEthTx_DataReaderView &);
            };
        }

    }

}

#endif
