#ifndef _H_3B38047344B761CDBBCDFDC00E58A603_EsrStatus1_DCPS_H_
#define _H_3B38047344B761CDBBCDFDC00E58A603_EsrStatus1_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrStatus1_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrStatus1_TypeSupportInterface;

            typedef EsrStatus1_TypeSupportInterface * EsrStatus1_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus1_TypeSupportInterface> EsrStatus1_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrStatus1_TypeSupportInterface> EsrStatus1_TypeSupportInterface_out;


            class EsrStatus1_DataWriter;

            typedef EsrStatus1_DataWriter * EsrStatus1_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus1_DataWriter> EsrStatus1_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrStatus1_DataWriter> EsrStatus1_DataWriter_out;


            class EsrStatus1_DataReader;

            typedef EsrStatus1_DataReader * EsrStatus1_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus1_DataReader> EsrStatus1_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrStatus1_DataReader> EsrStatus1_DataReader_out;


            class EsrStatus1_DataReaderView;

            typedef EsrStatus1_DataReaderView * EsrStatus1_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus1_DataReaderView> EsrStatus1_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrStatus1_DataReaderView> EsrStatus1_DataReaderView_out;

            struct EsrStatus1_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrStatus1_, struct EsrStatus1_Seq_uniq_> EsrStatus1_Seq;
            typedef DDS_DCPSSequence_var < EsrStatus1_Seq> EsrStatus1_Seq_var;
            typedef DDS_DCPSSequence_out < EsrStatus1_Seq> EsrStatus1_Seq_out;

            class  EsrStatus1_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrStatus1_TypeSupportInterface_ptr _ptr_type;
                typedef EsrStatus1_TypeSupportInterface_var _var_type;

                static EsrStatus1_TypeSupportInterface_ptr _duplicate (EsrStatus1_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus1_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus1_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus1_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus1_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrStatus1_TypeSupportInterface () {};
                ~EsrStatus1_TypeSupportInterface () {};
            private:
                EsrStatus1_TypeSupportInterface (const EsrStatus1_TypeSupportInterface &);
                EsrStatus1_TypeSupportInterface & operator = (const EsrStatus1_TypeSupportInterface &);
            };

            class  EsrStatus1_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrStatus1_DataWriter_ptr _ptr_type;
                typedef EsrStatus1_DataWriter_var _var_type;

                static EsrStatus1_DataWriter_ptr _duplicate (EsrStatus1_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus1_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus1_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus1_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus1_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrStatus1_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrStatus1_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrStatus1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrStatus1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrStatus1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrStatus1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrStatus1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrStatus1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrStatus1_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrStatus1_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrStatus1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus1_& instance_data) = 0;

            protected:
                EsrStatus1_DataWriter () {};
                ~EsrStatus1_DataWriter () {};
            private:
                EsrStatus1_DataWriter (const EsrStatus1_DataWriter &);
                EsrStatus1_DataWriter & operator = (const EsrStatus1_DataWriter &);
            };

            class  EsrStatus1_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrStatus1_DataReader_ptr _ptr_type;
                typedef EsrStatus1_DataReader_var _var_type;

                static EsrStatus1_DataReader_ptr _duplicate (EsrStatus1_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus1_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus1_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus1_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus1_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus1_& instance) = 0;

            protected:
                EsrStatus1_DataReader () {};
                ~EsrStatus1_DataReader () {};
            private:
                EsrStatus1_DataReader (const EsrStatus1_DataReader &);
                EsrStatus1_DataReader & operator = (const EsrStatus1_DataReader &);
            };

            class  EsrStatus1_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrStatus1_DataReaderView_ptr _ptr_type;
                typedef EsrStatus1_DataReaderView_var _var_type;

                static EsrStatus1_DataReaderView_ptr _duplicate (EsrStatus1_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus1_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus1_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus1_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus1_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus1_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus1_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus1_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus1_& instance) = 0;

            protected:
                EsrStatus1_DataReaderView () {};
                ~EsrStatus1_DataReaderView () {};
            private:
                EsrStatus1_DataReaderView (const EsrStatus1_DataReaderView &);
                EsrStatus1_DataReaderView & operator = (const EsrStatus1_DataReaderView &);
            };
        }

    }

}

#endif
