#ifndef _H_3B23860DD82FFAF785F0DD8DDD7A95C2_EsrStatus2__H_
#define _H_3B23860DD82FFAF785F0DD8DDD7A95C2_EsrStatus2__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  EsrStatus2_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::String_mgr canmsg_;
                ::DDS::Octet rolling_count2_;
                ::DDS::Octet max_track_ack_;
                ::DDS::Boolean overheat_error_;
                ::DDS::Boolean range_perf_error_;
                ::DDS::Boolean internal_error_;
                ::DDS::Boolean xcvr_operational_;
                ::DDS::Boolean raw_data_mode_;
                ::DDS::UShort steer_angle_ack_;
                ::DDS::Octet temperature_;
                ::DDS::Float spd_comp_factor_;
                ::DDS::Octet grouping_mode_;
                ::DDS::Float yaw_rate_bias_;
                ::DDS::String_mgr sw_version_dsp_;
            };

            typedef DDS_DCPSStruct_var<EsrStatus2_> EsrStatus2__var;
            typedef DDS_DCPSStruct_out < EsrStatus2_> EsrStatus2__out;

        }

    }

}

#endif /* _H_3B23860DD82FFAF785F0DD8DDD7A95C2_EsrStatus2__H_ */
