#ifndef _H_1E9DDFB03EF78862F804B51983C304CA_EsrStatus3_DCPS_H_
#define _H_1E9DDFB03EF78862F804B51983C304CA_EsrStatus3_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrStatus3_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrStatus3_TypeSupportInterface;

            typedef EsrStatus3_TypeSupportInterface * EsrStatus3_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus3_TypeSupportInterface> EsrStatus3_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrStatus3_TypeSupportInterface> EsrStatus3_TypeSupportInterface_out;


            class EsrStatus3_DataWriter;

            typedef EsrStatus3_DataWriter * EsrStatus3_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus3_DataWriter> EsrStatus3_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrStatus3_DataWriter> EsrStatus3_DataWriter_out;


            class EsrStatus3_DataReader;

            typedef EsrStatus3_DataReader * EsrStatus3_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus3_DataReader> EsrStatus3_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrStatus3_DataReader> EsrStatus3_DataReader_out;


            class EsrStatus3_DataReaderView;

            typedef EsrStatus3_DataReaderView * EsrStatus3_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus3_DataReaderView> EsrStatus3_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrStatus3_DataReaderView> EsrStatus3_DataReaderView_out;

            struct EsrStatus3_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrStatus3_, struct EsrStatus3_Seq_uniq_> EsrStatus3_Seq;
            typedef DDS_DCPSSequence_var < EsrStatus3_Seq> EsrStatus3_Seq_var;
            typedef DDS_DCPSSequence_out < EsrStatus3_Seq> EsrStatus3_Seq_out;

            class  EsrStatus3_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrStatus3_TypeSupportInterface_ptr _ptr_type;
                typedef EsrStatus3_TypeSupportInterface_var _var_type;

                static EsrStatus3_TypeSupportInterface_ptr _duplicate (EsrStatus3_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus3_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus3_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus3_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus3_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrStatus3_TypeSupportInterface () {};
                ~EsrStatus3_TypeSupportInterface () {};
            private:
                EsrStatus3_TypeSupportInterface (const EsrStatus3_TypeSupportInterface &);
                EsrStatus3_TypeSupportInterface & operator = (const EsrStatus3_TypeSupportInterface &);
            };

            class  EsrStatus3_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrStatus3_DataWriter_ptr _ptr_type;
                typedef EsrStatus3_DataWriter_var _var_type;

                static EsrStatus3_DataWriter_ptr _duplicate (EsrStatus3_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus3_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus3_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus3_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus3_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrStatus3_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrStatus3_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrStatus3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrStatus3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrStatus3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrStatus3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrStatus3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrStatus3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrStatus3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrStatus3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrStatus3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus3_& instance_data) = 0;

            protected:
                EsrStatus3_DataWriter () {};
                ~EsrStatus3_DataWriter () {};
            private:
                EsrStatus3_DataWriter (const EsrStatus3_DataWriter &);
                EsrStatus3_DataWriter & operator = (const EsrStatus3_DataWriter &);
            };

            class  EsrStatus3_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrStatus3_DataReader_ptr _ptr_type;
                typedef EsrStatus3_DataReader_var _var_type;

                static EsrStatus3_DataReader_ptr _duplicate (EsrStatus3_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus3_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus3_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus3_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus3_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus3_& instance) = 0;

            protected:
                EsrStatus3_DataReader () {};
                ~EsrStatus3_DataReader () {};
            private:
                EsrStatus3_DataReader (const EsrStatus3_DataReader &);
                EsrStatus3_DataReader & operator = (const EsrStatus3_DataReader &);
            };

            class  EsrStatus3_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrStatus3_DataReaderView_ptr _ptr_type;
                typedef EsrStatus3_DataReaderView_var _var_type;

                static EsrStatus3_DataReaderView_ptr _duplicate (EsrStatus3_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus3_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus3_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus3_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus3_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus3_& instance) = 0;

            protected:
                EsrStatus3_DataReaderView () {};
                ~EsrStatus3_DataReaderView () {};
            private:
                EsrStatus3_DataReaderView (const EsrStatus3_DataReaderView &);
                EsrStatus3_DataReaderView & operator = (const EsrStatus3_DataReaderView &);
            };
        }

    }

}

#endif
