#ifndef _H_5DB2D5D0988195FE6C54554CD94DD255_EsrStatus8_DCPS_H_
#define _H_5DB2D5D0988195FE6C54554CD94DD255_EsrStatus8_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrStatus8_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrStatus8_TypeSupportInterface;

            typedef EsrStatus8_TypeSupportInterface * EsrStatus8_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus8_TypeSupportInterface> EsrStatus8_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrStatus8_TypeSupportInterface> EsrStatus8_TypeSupportInterface_out;


            class EsrStatus8_DataWriter;

            typedef EsrStatus8_DataWriter * EsrStatus8_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus8_DataWriter> EsrStatus8_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrStatus8_DataWriter> EsrStatus8_DataWriter_out;


            class EsrStatus8_DataReader;

            typedef EsrStatus8_DataReader * EsrStatus8_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus8_DataReader> EsrStatus8_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrStatus8_DataReader> EsrStatus8_DataReader_out;


            class EsrStatus8_DataReaderView;

            typedef EsrStatus8_DataReaderView * EsrStatus8_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrStatus8_DataReaderView> EsrStatus8_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrStatus8_DataReaderView> EsrStatus8_DataReaderView_out;

            struct EsrStatus8_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrStatus8_, struct EsrStatus8_Seq_uniq_> EsrStatus8_Seq;
            typedef DDS_DCPSSequence_var < EsrStatus8_Seq> EsrStatus8_Seq_var;
            typedef DDS_DCPSSequence_out < EsrStatus8_Seq> EsrStatus8_Seq_out;

            class  EsrStatus8_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrStatus8_TypeSupportInterface_ptr _ptr_type;
                typedef EsrStatus8_TypeSupportInterface_var _var_type;

                static EsrStatus8_TypeSupportInterface_ptr _duplicate (EsrStatus8_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus8_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus8_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus8_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus8_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrStatus8_TypeSupportInterface () {};
                ~EsrStatus8_TypeSupportInterface () {};
            private:
                EsrStatus8_TypeSupportInterface (const EsrStatus8_TypeSupportInterface &);
                EsrStatus8_TypeSupportInterface & operator = (const EsrStatus8_TypeSupportInterface &);
            };

            class  EsrStatus8_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrStatus8_DataWriter_ptr _ptr_type;
                typedef EsrStatus8_DataWriter_var _var_type;

                static EsrStatus8_DataWriter_ptr _duplicate (EsrStatus8_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus8_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus8_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus8_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus8_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrStatus8_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrStatus8_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrStatus8_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrStatus8_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrStatus8_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrStatus8_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrStatus8_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrStatus8_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrStatus8_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrStatus8_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrStatus8_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus8_& instance_data) = 0;

            protected:
                EsrStatus8_DataWriter () {};
                ~EsrStatus8_DataWriter () {};
            private:
                EsrStatus8_DataWriter (const EsrStatus8_DataWriter &);
                EsrStatus8_DataWriter & operator = (const EsrStatus8_DataWriter &);
            };

            class  EsrStatus8_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrStatus8_DataReader_ptr _ptr_type;
                typedef EsrStatus8_DataReader_var _var_type;

                static EsrStatus8_DataReader_ptr _duplicate (EsrStatus8_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus8_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus8_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus8_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus8_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus8_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus8_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus8_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus8_& instance) = 0;

            protected:
                EsrStatus8_DataReader () {};
                ~EsrStatus8_DataReader () {};
            private:
                EsrStatus8_DataReader (const EsrStatus8_DataReader &);
                EsrStatus8_DataReader & operator = (const EsrStatus8_DataReader &);
            };

            class  EsrStatus8_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrStatus8_DataReaderView_ptr _ptr_type;
                typedef EsrStatus8_DataReaderView_var _var_type;

                static EsrStatus8_DataReaderView_ptr _duplicate (EsrStatus8_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrStatus8_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrStatus8_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrStatus8_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrStatus8_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrStatus8_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrStatus8_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrStatus8_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrStatus8_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrStatus8_& instance) = 0;

            protected:
                EsrStatus8_DataReaderView () {};
                ~EsrStatus8_DataReaderView () {};
            private:
                EsrStatus8_DataReaderView (const EsrStatus8_DataReaderView &);
                EsrStatus8_DataReaderView & operator = (const EsrStatus8_DataReaderView &);
            };
        }

    }

}

#endif
