#ifndef _H_4AD8329C699E0BFE82ABA4373137C437_EsrTrack__H_
#define _H_4AD8329C699E0BFE82ABA4373137C437_EsrTrack__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  EsrTrack_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::String_mgr canmsg_;
                ::DDS::Octet track_id_;
                ::DDS::Float track_lat_rate_;
                ::DDS::Boolean track_group_changed_;
                ::DDS::Octet track_status_;
                ::DDS::Float track_angle_;
                ::DDS::Float track_range_;
                ::DDS::Boolean track_bridge_object_;
                ::DDS::Boolean track_rolling_count_;
                ::DDS::Float track_width_;
                ::DDS::Float track_range_accel_;
                ::DDS::Octet track_med_range_mode_;
                ::DDS::Float track_range_rate_;
            };

            typedef DDS_DCPSStruct_var<EsrTrack_> EsrTrack__var;
            typedef DDS_DCPSStruct_out < EsrTrack_> EsrTrack__out;

        }

    }

}

#endif /* _H_4AD8329C699E0BFE82ABA4373137C437_EsrTrack__H_ */
