#ifndef _H_CB948B3A21354D420BD5B27DCD30F03E_EsrValid2_DCPS_H_
#define _H_CB948B3A21354D420BD5B27DCD30F03E_EsrValid2_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrValid2_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrValid2_TypeSupportInterface;

            typedef EsrValid2_TypeSupportInterface * EsrValid2_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrValid2_TypeSupportInterface> EsrValid2_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrValid2_TypeSupportInterface> EsrValid2_TypeSupportInterface_out;


            class EsrValid2_DataWriter;

            typedef EsrValid2_DataWriter * EsrValid2_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrValid2_DataWriter> EsrValid2_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrValid2_DataWriter> EsrValid2_DataWriter_out;


            class EsrValid2_DataReader;

            typedef EsrValid2_DataReader * EsrValid2_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrValid2_DataReader> EsrValid2_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrValid2_DataReader> EsrValid2_DataReader_out;


            class EsrValid2_DataReaderView;

            typedef EsrValid2_DataReaderView * EsrValid2_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrValid2_DataReaderView> EsrValid2_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrValid2_DataReaderView> EsrValid2_DataReaderView_out;

            struct EsrValid2_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrValid2_, struct EsrValid2_Seq_uniq_> EsrValid2_Seq;
            typedef DDS_DCPSSequence_var < EsrValid2_Seq> EsrValid2_Seq_var;
            typedef DDS_DCPSSequence_out < EsrValid2_Seq> EsrValid2_Seq_out;

            class  EsrValid2_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrValid2_TypeSupportInterface_ptr _ptr_type;
                typedef EsrValid2_TypeSupportInterface_var _var_type;

                static EsrValid2_TypeSupportInterface_ptr _duplicate (EsrValid2_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrValid2_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrValid2_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrValid2_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrValid2_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrValid2_TypeSupportInterface () {};
                ~EsrValid2_TypeSupportInterface () {};
            private:
                EsrValid2_TypeSupportInterface (const EsrValid2_TypeSupportInterface &);
                EsrValid2_TypeSupportInterface & operator = (const EsrValid2_TypeSupportInterface &);
            };

            class  EsrValid2_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrValid2_DataWriter_ptr _ptr_type;
                typedef EsrValid2_DataWriter_var _var_type;

                static EsrValid2_DataWriter_ptr _duplicate (EsrValid2_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrValid2_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrValid2_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrValid2_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrValid2_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrValid2_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrValid2_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrValid2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrValid2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrValid2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrValid2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrValid2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrValid2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrValid2_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrValid2_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrValid2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrValid2_& instance_data) = 0;

            protected:
                EsrValid2_DataWriter () {};
                ~EsrValid2_DataWriter () {};
            private:
                EsrValid2_DataWriter (const EsrValid2_DataWriter &);
                EsrValid2_DataWriter & operator = (const EsrValid2_DataWriter &);
            };

            class  EsrValid2_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrValid2_DataReader_ptr _ptr_type;
                typedef EsrValid2_DataReader_var _var_type;

                static EsrValid2_DataReader_ptr _duplicate (EsrValid2_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrValid2_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrValid2_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrValid2_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrValid2_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrValid2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrValid2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrValid2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrValid2_& instance) = 0;

            protected:
                EsrValid2_DataReader () {};
                ~EsrValid2_DataReader () {};
            private:
                EsrValid2_DataReader (const EsrValid2_DataReader &);
                EsrValid2_DataReader & operator = (const EsrValid2_DataReader &);
            };

            class  EsrValid2_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrValid2_DataReaderView_ptr _ptr_type;
                typedef EsrValid2_DataReaderView_var _var_type;

                static EsrValid2_DataReaderView_ptr _duplicate (EsrValid2_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrValid2_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrValid2_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrValid2_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrValid2_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrValid2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrValid2_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrValid2_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrValid2_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrValid2_& instance) = 0;

            protected:
                EsrValid2_DataReaderView () {};
                ~EsrValid2_DataReaderView () {};
            private:
                EsrValid2_DataReaderView (const EsrValid2_DataReaderView &);
                EsrValid2_DataReaderView & operator = (const EsrValid2_DataReaderView &);
            };
        }

    }

}

#endif
