#ifndef _H_5CF50FA7DD7416441654B0E1CF6EDA29_EsrVehicle1__H_
#define _H_5CF50FA7DD7416441654B0E1CF6EDA29_EsrVehicle1__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  EsrVehicle1_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Float vehicle_speed_;
                ::DDS::Boolean speed_direction_;
                ::DDS::Float yaw_rate_;
                ::DDS::Boolean yaw_rate_valid_;
                ::DDS::Short radius_curvature_;
                ::DDS::Boolean steering_angle_valid_;
                ::DDS::Boolean steering_angle_sign_;
                ::DDS::UShort steering_angle_;
                ::DDS::UShort steering_angle_rate_;
                ::DDS::Boolean steering_angle_rate_sign_;
            };

            typedef DDS_DCPSStruct_var<EsrVehicle1_> EsrVehicle1__var;
            typedef DDS_DCPSStruct_out < EsrVehicle1_> EsrVehicle1__out;

        }

    }

}

#endif /* _H_5CF50FA7DD7416441654B0E1CF6EDA29_EsrVehicle1__H_ */
