#ifndef _H_94F9491C553C1ECC2D4C13AD5DD5AB07_EsrVehicle3__H_
#define _H_94F9491C553C1ECC2D4C13AD5DD5AB07_EsrVehicle3__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  EsrVehicle3_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean long_accel_valid_;
                ::DDS::Boolean lat_accel_valid_;
                ::DDS::Float lat_accel_;
                ::DDS::Float long_accel_;
                ::DDS::Octet radar_fov_lr_;
                ::DDS::Octet radar_fov_mr_;
                ::DDS::Boolean auto_align_disable_;
                ::DDS::Octet radar_height_;
                ::DDS::Boolean serv_align_type_;
                ::DDS::Boolean serv_align_enable_;
                ::DDS::UShort align_avg_ctr_total_;
                ::DDS::Boolean auto_align_converged_;
                ::DDS::Octet wheel_slip_;
                ::DDS::Octet serv_align_updates_need_;
                ::DDS::Octet angle_mounting_offset_;
            };

            typedef DDS_DCPSStruct_var<EsrVehicle3_> EsrVehicle3__var;
            typedef DDS_DCPSStruct_out < EsrVehicle3_> EsrVehicle3__out;

        }

    }

}

#endif /* _H_94F9491C553C1ECC2D4C13AD5DD5AB07_EsrVehicle3__H_ */
