#ifndef _H_94F9491C553C1ECC2D4C13AD5DD5AB07_EsrVehicle3_DCPS_H_
#define _H_94F9491C553C1ECC2D4C13AD5DD5AB07_EsrVehicle3_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrVehicle3_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrVehicle3_TypeSupportInterface;

            typedef EsrVehicle3_TypeSupportInterface * EsrVehicle3_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle3_TypeSupportInterface> EsrVehicle3_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrVehicle3_TypeSupportInterface> EsrVehicle3_TypeSupportInterface_out;


            class EsrVehicle3_DataWriter;

            typedef EsrVehicle3_DataWriter * EsrVehicle3_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle3_DataWriter> EsrVehicle3_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrVehicle3_DataWriter> EsrVehicle3_DataWriter_out;


            class EsrVehicle3_DataReader;

            typedef EsrVehicle3_DataReader * EsrVehicle3_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle3_DataReader> EsrVehicle3_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrVehicle3_DataReader> EsrVehicle3_DataReader_out;


            class EsrVehicle3_DataReaderView;

            typedef EsrVehicle3_DataReaderView * EsrVehicle3_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle3_DataReaderView> EsrVehicle3_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrVehicle3_DataReaderView> EsrVehicle3_DataReaderView_out;

            struct EsrVehicle3_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrVehicle3_, struct EsrVehicle3_Seq_uniq_> EsrVehicle3_Seq;
            typedef DDS_DCPSSequence_var < EsrVehicle3_Seq> EsrVehicle3_Seq_var;
            typedef DDS_DCPSSequence_out < EsrVehicle3_Seq> EsrVehicle3_Seq_out;

            class  EsrVehicle3_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrVehicle3_TypeSupportInterface_ptr _ptr_type;
                typedef EsrVehicle3_TypeSupportInterface_var _var_type;

                static EsrVehicle3_TypeSupportInterface_ptr _duplicate (EsrVehicle3_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle3_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle3_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle3_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle3_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrVehicle3_TypeSupportInterface () {};
                ~EsrVehicle3_TypeSupportInterface () {};
            private:
                EsrVehicle3_TypeSupportInterface (const EsrVehicle3_TypeSupportInterface &);
                EsrVehicle3_TypeSupportInterface & operator = (const EsrVehicle3_TypeSupportInterface &);
            };

            class  EsrVehicle3_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrVehicle3_DataWriter_ptr _ptr_type;
                typedef EsrVehicle3_DataWriter_var _var_type;

                static EsrVehicle3_DataWriter_ptr _duplicate (EsrVehicle3_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle3_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle3_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle3_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle3_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrVehicle3_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrVehicle3_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrVehicle3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrVehicle3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrVehicle3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrVehicle3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrVehicle3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrVehicle3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrVehicle3_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrVehicle3_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrVehicle3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle3_& instance_data) = 0;

            protected:
                EsrVehicle3_DataWriter () {};
                ~EsrVehicle3_DataWriter () {};
            private:
                EsrVehicle3_DataWriter (const EsrVehicle3_DataWriter &);
                EsrVehicle3_DataWriter & operator = (const EsrVehicle3_DataWriter &);
            };

            class  EsrVehicle3_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrVehicle3_DataReader_ptr _ptr_type;
                typedef EsrVehicle3_DataReader_var _var_type;

                static EsrVehicle3_DataReader_ptr _duplicate (EsrVehicle3_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle3_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle3_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle3_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle3_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrVehicle3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrVehicle3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrVehicle3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle3_& instance) = 0;

            protected:
                EsrVehicle3_DataReader () {};
                ~EsrVehicle3_DataReader () {};
            private:
                EsrVehicle3_DataReader (const EsrVehicle3_DataReader &);
                EsrVehicle3_DataReader & operator = (const EsrVehicle3_DataReader &);
            };

            class  EsrVehicle3_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrVehicle3_DataReaderView_ptr _ptr_type;
                typedef EsrVehicle3_DataReaderView_var _var_type;

                static EsrVehicle3_DataReaderView_ptr _duplicate (EsrVehicle3_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle3_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle3_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle3_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle3_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrVehicle3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrVehicle3_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrVehicle3_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrVehicle3_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle3_& instance) = 0;

            protected:
                EsrVehicle3_DataReaderView () {};
                ~EsrVehicle3_DataReaderView () {};
            private:
                EsrVehicle3_DataReaderView (const EsrVehicle3_DataReaderView &);
                EsrVehicle3_DataReaderView & operator = (const EsrVehicle3_DataReaderView &);
            };
        }

    }

}

#endif
