#ifndef _H_0164E260CAFD75A66D148F593D7FB234_EsrVehicle5_DCPS_H_
#define _H_0164E260CAFD75A66D148F593D7FB234_EsrVehicle5_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "EsrVehicle5_.h"


namespace delphi_esr_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class EsrVehicle5_TypeSupportInterface;

            typedef EsrVehicle5_TypeSupportInterface * EsrVehicle5_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle5_TypeSupportInterface> EsrVehicle5_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < EsrVehicle5_TypeSupportInterface> EsrVehicle5_TypeSupportInterface_out;


            class EsrVehicle5_DataWriter;

            typedef EsrVehicle5_DataWriter * EsrVehicle5_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle5_DataWriter> EsrVehicle5_DataWriter_var;
            typedef DDS_DCPSInterface_out < EsrVehicle5_DataWriter> EsrVehicle5_DataWriter_out;


            class EsrVehicle5_DataReader;

            typedef EsrVehicle5_DataReader * EsrVehicle5_DataReader_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle5_DataReader> EsrVehicle5_DataReader_var;
            typedef DDS_DCPSInterface_out < EsrVehicle5_DataReader> EsrVehicle5_DataReader_out;


            class EsrVehicle5_DataReaderView;

            typedef EsrVehicle5_DataReaderView * EsrVehicle5_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < EsrVehicle5_DataReaderView> EsrVehicle5_DataReaderView_var;
            typedef DDS_DCPSInterface_out < EsrVehicle5_DataReaderView> EsrVehicle5_DataReaderView_out;

            struct EsrVehicle5_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < EsrVehicle5_, struct EsrVehicle5_Seq_uniq_> EsrVehicle5_Seq;
            typedef DDS_DCPSSequence_var < EsrVehicle5_Seq> EsrVehicle5_Seq_var;
            typedef DDS_DCPSSequence_out < EsrVehicle5_Seq> EsrVehicle5_Seq_out;

            class  EsrVehicle5_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef EsrVehicle5_TypeSupportInterface_ptr _ptr_type;
                typedef EsrVehicle5_TypeSupportInterface_var _var_type;

                static EsrVehicle5_TypeSupportInterface_ptr _duplicate (EsrVehicle5_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle5_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle5_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle5_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle5_TypeSupportInterface_ptr _this () { return this; }


            protected:
                EsrVehicle5_TypeSupportInterface () {};
                ~EsrVehicle5_TypeSupportInterface () {};
            private:
                EsrVehicle5_TypeSupportInterface (const EsrVehicle5_TypeSupportInterface &);
                EsrVehicle5_TypeSupportInterface & operator = (const EsrVehicle5_TypeSupportInterface &);
            };

            class  EsrVehicle5_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef EsrVehicle5_DataWriter_ptr _ptr_type;
                typedef EsrVehicle5_DataWriter_var _var_type;

                static EsrVehicle5_DataWriter_ptr _duplicate (EsrVehicle5_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle5_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle5_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle5_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle5_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const EsrVehicle5_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const EsrVehicle5_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const EsrVehicle5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const EsrVehicle5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const EsrVehicle5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const EsrVehicle5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const EsrVehicle5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const EsrVehicle5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const EsrVehicle5_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const EsrVehicle5_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (EsrVehicle5_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle5_& instance_data) = 0;

            protected:
                EsrVehicle5_DataWriter () {};
                ~EsrVehicle5_DataWriter () {};
            private:
                EsrVehicle5_DataWriter (const EsrVehicle5_DataWriter &);
                EsrVehicle5_DataWriter & operator = (const EsrVehicle5_DataWriter &);
            };

            class  EsrVehicle5_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef EsrVehicle5_DataReader_ptr _ptr_type;
                typedef EsrVehicle5_DataReader_var _var_type;

                static EsrVehicle5_DataReader_ptr _duplicate (EsrVehicle5_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle5_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle5_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle5_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle5_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrVehicle5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrVehicle5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrVehicle5_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle5_& instance) = 0;

            protected:
                EsrVehicle5_DataReader () {};
                ~EsrVehicle5_DataReader () {};
            private:
                EsrVehicle5_DataReader (const EsrVehicle5_DataReader &);
                EsrVehicle5_DataReader & operator = (const EsrVehicle5_DataReader &);
            };

            class  EsrVehicle5_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef EsrVehicle5_DataReaderView_ptr _ptr_type;
                typedef EsrVehicle5_DataReaderView_var _var_type;

                static EsrVehicle5_DataReaderView_ptr _duplicate (EsrVehicle5_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static EsrVehicle5_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static EsrVehicle5_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static EsrVehicle5_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                EsrVehicle5_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (EsrVehicle5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (EsrVehicle5_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (EsrVehicle5_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (EsrVehicle5_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const EsrVehicle5_& instance) = 0;

            protected:
                EsrVehicle5_DataReaderView () {};
                ~EsrVehicle5_DataReaderView () {};
            private:
                EsrVehicle5_DataReaderView (const EsrVehicle5_DataReaderView &);
                EsrVehicle5_DataReaderView & operator = (const EsrVehicle5_DataReaderView &);
            };
        }

    }

}

#endif
